{ (C) 1998-1999  Alexander N. Naumov (2:5020/423.11@fidonet) }

{$N+}
unit Huge;

interface

type
  HugeInt = array [0..1] of LongInt;

procedure HugeInc(var X: HugeInt; N: LongInt);
procedure HugeDec(var X: HugeInt; N: LongInt);
function HugeCompare(const X, Y: HugeInt): Integer; { -1; 0; 1}
function HugeStep(const X, Y: HugeInt; MaxStep: LongInt): LongInt;
function HugeToReal(const X: HugeInt): Extended;
procedure RealToHuge(const X: Extended; var V: HugeInt);

implementation

{$L HI64}
procedure HugeInc(var X: HugeInt; N: LongInt); external;

procedure HugeDec(var X: HugeInt; N: LongInt); external;

function HugeCompare(const X, Y: HugeInt): Integer; external;

function HugeStep(const X, Y: HugeInt; MaxStep: LongInt): LongInt; external;

const
  Two64 = 4294967296.0; { 2^64 = $100000000 }

function HugeToReal(const X: HugeInt): Extended;
begin
  HugeToReal := X[0] + X[1]*Two64;
end;

procedure RealToHuge(const X: Extended; var V: HugeInt);
begin
  V[1] := Trunc(X/Two64);
  V[0] := Trunc(X-V[1]*Two64);
end;

end.