{ (C) 1998-1999  Alexander N. Naumov (2:5020/423.11@fidonet) }

unit Int13X;

interface

uses
  Huge;

const
  xAccess    = $0001;
  xRemovable = $0002;
  xEDD       = $0004;

type
  XConfig = record
    Version:   Byte;
    exVersion: Byte;
    Support:   Word;
  end;

function CheckDrive(Drive: Byte; var Cfg: XConfig): Boolean;

const
  xValidCHS   = $0002;
  xMaximumCHS = $0040;

type
  XParameters = record
    Size:            Word;
    Flags:           Word;
    Cylinders:       LongInt;
    Heads:           LongInt;
    SectorsPerTrack: LongInt;
    Sectors:         HugeInt;
    BytesPerSector:  Word;
    { v2.0+ }
    EDD:             Pointer;
  end;

function GetDriveParameters(Drive: Byte; var Param: XParameters): Byte;

const
  xRead   = $4200;
  xWrite  = $4300;
  xVerify = $4400;
  xSeek   = $4700;

type
  XPacket = record
    Size:   Word;   { :Byte; Reserved: Byte; }
    Count:  Word;
    Buffer: Pointer;
    Start:  HugeInt;
  end;

function RequestDrive(Drive: Byte; Req: Word; var Packet: XPacket): Byte;

procedure CHStoBlock(NumHeads, SectorsPerTrack: LongInt; Cylinder, Head, Sector: LongInt; var Block: HugeInt);

implementation

function CheckDrive(Drive: Byte; var Cfg: XConfig): Boolean; assembler;
asm
        MOV     AH, 41H
        MOV     BX, 055AAH
        MOV     DL, Drive
        INT     13H
        MOV     AL, 0
        JC      @@1
        CMP     BX, 0AA55H
        JNE     @@1
        LES     DI, Cfg
        MOV     [ES:DI].XConfig.Version, AH
        MOV     [ES:DI].XConfig.exVersion, DH
        MOV     [ES:DI].XConfig.Support, CX
        INC     AL
    @@1:
end;

function GetDriveParameters(Drive: Byte; var Param: XParameters): Byte; assembler;
asm
        PUSH    DS
        MOV     AH, 48H
        MOV     DL, Drive
        LDS     SI, Param
        MOV     [DS:SI].xParameters.Size, TYPE xParameters
        INT     13H
        MOV     AL, AH
        JC      @@1
        XOR     AL, AL
    @@1:
        POP     DS
end;

function RequestDrive(Drive: Byte; Req: Word; var Packet: XPacket): Byte; assembler;
asm
        PUSH    DS
        MOV     AX, Req
        MOV     DL, Drive
        LDS     SI, Packet
        MOV     [DS:SI].xPacket.Size, TYPE xPacket
        INT     13H
        MOV     AL, AH
        JC      @@1
        XOR     AL, AL
    @@1:
        POP     DS
end;

{$L HI64}
procedure CHStoBlock(NumHeads, SectorsPerTrack: LongInt; Cylinder, Head, Sector: LongInt; var Block: HugeInt); external;

end.